#!/usr/bin/fish

set app_names 'Text Editor' 'File Manager' 'Web Browser' 'System Info'
set app_cmds nano ranger lynx htop

set folder_names Home Documents Downloads Repos
set folder_paths $HOME $HOME/Documents $HOME/Downloads $HOME/repos

set i none

while test $i != q
    for j in (seq (count $app_names))
        echo "$j: $app_names[$j]"
    end
     
    echo "b: Go to folder bookmark"
    echo "n: Navigate filesystem"
    echo "r: Run a command"
    echo "q: Quit"
    echo "Current directory: $PWD"
    read -P "Command> " i
    
    if test $i = b
        for j in (seq (count $folder_names))
            echo "$j: $folder_names[$j]"
        end
	echo "Current directory: $PWD"

	read -P "Folder> " f
        
	if test $f != q
            cd $folder_paths[$f] 
        end
    else if test $i = n
        set k none
	
        while test $k != q
	   echo "u: Go up a folder"
	   echo "c: Change to a folder"
	   echo "l: List files"
	   echo "f: List folders"
	   echo "q: Quit"
	   echo "Current directory: $PWD"

           read -P "Command> " k

            if test $k = u
                cd ..
            else if test $k = c
                read -P "Enter directory> " dir_name
                cd $dir_name 
            else if test $k = f
                ls -d */
            else if test $k = l
                ls 
            end
        end
    else if test $i = r 
        read -P "Command> " cmd
        $cmd
    else if test $i != q
        echo "Running app[$i]: $app_cmds[$i]"
        $app_cmds[$i]
    end
end

echo "Exiting to shell" 
echo "Type ./launcher.fish to restart launcher"

